<?php

	# 		Radar Canada
	# 		Namespace:		radarCA
	#		Meteotemplate Block
	
	# 		v1.1	Mar 11, 2016
	#			- added responsiveness
	
	# 		v1.2	Apr 11, 2016
	#			- bug fixes
	
	#		v2.0	2016-11-19
	#			- improved image swap
	#			- image zoom in a popup
	#			- spinner when loading
	#			- added slider
	#			- block optimization
	
	$thisBlockVersion = "2.0";

	$time = microtime();
	$time = explode(' ', $time);
	$time = $time[1] + $time[0];
	$blockStartTime = $time;

	$errorLog[] = array("","%c Loading Block Radar Canada ".$thisBlockVersion."','font-weight:bold;color:green");
	
	if(file_exists("settings.php")){
		include("settings.php");
	}
	else{
		echo "Please go to your admin section and go through the settings for this block first.";
		die();
	}include("settings.php");
	
	$errorLog[] = array("","Selected region: ".$regionalRadarCanada);
	
	// load theme
	$designTheme = json_decode(file_get_contents("../../css/theme.txt"),true);
	$theme = $designTheme['theme'];
	
	include("../../../config.php");
	include("../../../css/design.php");
	include("../../../scripts/functions.php");
	
	$languageRaw = file_get_contents($baseURL."lang/gb.php");
	$language['gb'] = json_decode($languageRaw,true);
	$languageRaw = file_get_contents($baseURL."lang/".$lang.".php");
	$language[$lang] = json_decode($languageRaw,true);
	
	$urlRadarCanada = file_get_contents("https://weather.gc.ca/radar/index_e.html");
	$errorLog[] = array("","Loading data from https://weather.gc.ca/radar/index_e.html");
	
	$recent = '';
	// image fetching script based on http://saratoga-weather.org/index.php
	if(preg_match('|src="/data/radar/detailed/temp_image/\S+/(\S+).GIF"|is',$urlRadarCanada,$recentMatch)) {
	   $recent = $recentMatch[1];
	}
	$start = strpos($urlRadarCanada, '<div class="col-lg-3 col-md-4 col-xs-5">');
	$finish = strpos($urlRadarCanada, '</ul>',$start);
	$length = $finish-$start;
	$shortList = substr($urlRadarCanada, $start, $length);
	$foundImages = preg_match_all("!(display|base)\=\'(.*?)\'!", $shortList, $matches);
	if ($foundImages > 2 && $matches[1][1] == "base") {
		for ($i = 1; $i <= $foundImages; $i++) {
			unset($matches[0][0]);
			unset($matches[1][0]);
			unset($matches[2][0]);
			if ($i < $foundImages && $matches[1][1] != "base") {
				break;
			}
		}
		$matches[0] = array_values($matches[0]);
		$matches[1] = array_values($matches[1]);
		$matches[2] = array_values($matches[2]);
	}
	if($recent <> '') {
		$imgList[] = $recent;
		foreach ($matches[2] as $i => $ourImg) {
			$imgList[] = $ourImg;
		}
	} 
	else {
		$imgList = $matches[2];
	}
	$imageUrlsRadarCanada = array();
	foreach($imgList as $imageRadarCanada){
		$imgURLRadarCanada = "https://weather.gc.ca/data/radar/detailed/temp_image/COMPOSITE_NAT/".$imageRadarCanada.".GIF";
		array_push($imageUrlsRadarCanada,$imgURLRadarCanada);
	}
	$imageUrlsRadarCanada = array_reverse($imageUrlsRadarCanada);
	
	if(count($imageUrlsRadarCanada)==0){
		$urlRadarCanada = curlMain("https://weather.gc.ca/radar/index_e.html",5);
	
		$recent = '';
		// image fetching script based on http://saratoga-weather.org/index.php
		if(preg_match('|src="/data/radar/detailed/temp_image/\S+/(\S+).GIF"|is',$urlRadarCanada,$recentMatch)) {
		   $recent = $recentMatch[1];
		}
		$start = strpos($urlRadarCanada, '<div class="col-lg-3 col-md-4 col-xs-5">');
		$finish = strpos($urlRadarCanada, '</ul>',$start);
		$length = $finish-$start;
		$shortList = substr($urlRadarCanada, $start, $length);
		$foundImages = preg_match_all("!(display|base)\=\'(.*?)\'!", $shortList, $matches);
		if ($foundImages > 2 && $matches[1][1] == "base") {
			for ($i = 1; $i <= $foundImages; $i++) {
				unset($matches[0][0]);
				unset($matches[1][0]);
				unset($matches[2][0]);
				if ($i < $foundImages && $matches[1][1] != "base") {
					break;
				}
			}
			$matches[0] = array_values($matches[0]);
			$matches[1] = array_values($matches[1]);
			$matches[2] = array_values($matches[2]);
		}
		if($recent <> '') {
			$imgList[] = $recent;
			foreach ($matches[2] as $i => $ourImg) {
				$imgList[] = $ourImg;
			}
		} 
		else {
			$imgList = $matches[2];
		}
		$imageUrlsRadarCanada = array();
		foreach($imgList as $imageRadarCanada){
			$imgURLRadarCanada = "https://weather.gc.ca/data/radar/detailed/temp_image/COMPOSITE_NAT/".$imageRadarCanada.".GIF";
			array_push($imageUrlsRadarCanada,$imgURLRadarCanada);
		}
		$imageUrlsRadarCanada = array_reverse($imageUrlsRadarCanada);
		
	}
?>
	
	<style>
		#currentCanadaNational, #currentCanadaNational2{
			display: inline-block;
			padding-left: 5px;
			padding-right: 5px;
		}
		#canadaNationalRadar, #canadaRegionalRadar{
			width:100%;
			opacity: 0.85;
			border: 1px solid #<?php echo $color_schemes[$design2]['700']?>;
			cursor: pointer;
		}
		#canadaNationalRadar:hover, #canadaRegionalRadar:hover{
			opacity: 1;
		}
		#canadaRadarDiv{
			width: 98%;
			<?php
				if($theme=="dark"){
			?>
					border: 1px solid #<?php echo $color_schemes[$design2]['700']?>;
					background: #<?php echo $color_schemes[$design]['900']?>;
			<?php
				}
			?>
			<?php
				if($theme=="light"){
			?>
					border: 1px solid #<?php echo $color_schemes[$design2]['400']?>;
					background: #<?php echo $color_schemes[$design]['300']?>;
			<?php
				}
			?>
			border-radius: 3px;
			padding: 5px;
			margin-bottom: 10px;
		}
		.controlIconRadarCA{
			width: 25px;
			opacity: 0.8;
			cursor: pointer;
		}
		.controlIconRadarCA:hover{
			opacity: 1
		}
	</style>
	<table style="width:100%">
		<tr>
			<td style="width:50%">
				<div id="canadaRadarWrapper" style="position:relative">
					<div id="radarCASpinnerNational" style="position:absolute;top:100px;width:100%;text-align:center"></div>
					<img src="<?php echo $imageUrlsRadarCanada[count($imageUrlsRadarCanada)-1]?>" alt='' id="canadaNationalRadar" class="radarCaImage">		
				</div>
			</td>
			<td>
				<div id="canadaRadarRegionalWrapper" style="position:relative">
					<div id="radarCASpinnerRegional" style="position:absolute;top:100px;width:100%;text-align:center"></div>
					<img src='' id='canadaRegionalRadar' class='radarCaImage'>
				</div>
			</td>
		</tr>
		<tr>
			<td>
				<div id="sliderRadarCA" style="width:90%;margin: 0 auto"></div>
				<br>
				<img src="homepage/blocks/radarCA/icons/<?php echo $theme?>/play.png" class="controlIconRadarCA" id="playRadarCA" alt=''>
				<img src="homepage/blocks/radarCA/icons/<?php echo $theme?>/pause.png" class="controlIconRadarCA" id="pauseRadarCA" alt=''>
			</td>
			<td style='vertical-align:top'>
				<select id="canadaRegionalRadarSelector" class="button" style="width:98%;margin:0 auto">
					<optgroup label="Pacific">
						<option value="WUJ">Aldergrove (near Vancouver)</option>
						<option value="XPG">Prince George</option>
						<option value="XSS">Silver Star Mountain (near Vernon)</option>
						<option value="XSI">Victoria</option>
					</optgroup>
					<optgroup label="Prairies">
						<option value="XBE">Bethune (near Regina)</option>
						<option value="WHK">Carvel (near Edmonton)</option>
						<option value="XFW">Foxwarren (near Brandon)</option>
						<option value="WHN">Jimmy Lake (near Cold Lake)</option>
						<option value="XRA">Radisson (near Sadkatoon)</option>
						<option value="XBU">Schuler (near Medicine Hat)</option>
						<option value="WWW">Spirit River (near Grande Prairie)</option>
						<option value="XSM">Strathmore (near Calgary)</option>
						<option value="XWL">Woodlands (near Winnipeg)</option>
					</optgroup>
					<optgroup label="Ontario">
						<option value="WBI">Britt (near Sudbury)</option>
						<option value="XDR">Dryden</option>
						<option value="WSO">Exeter (near London)</option>
						<option value="XFT">Franktown (near Ottawa)</option>
						<option value="WKR">King City (near Toronto)</option>
						<option value="WGJ">Montreal River (near Sault Ste Marie)</option>
						<option value="XTI">Northeast Ontario (near Timmins)</option>
						<option value="XNI">Superior West (near Thunder Bay)</option>
					</optgroup>
					<optgroup label="Quebec">
						<option value="WMB">Lac Castor (near Saguenay)</option>
						<option value="XLA">Landrienne (near Rouyn-Noranda)</option>
						<option value="WMN">McGill (near Montreal)</option>
						<option value="XAM">Val d'Irene (near Mont Joli)</option>
						<option value="WVY">Villeroy (near Trois-Rivieres)</option>
					</optgroup>
					<optgroup label="Atlantic">
						<option value="XNC">Chipman (near Fredericton)</option>
						<option value="XGO">Halifax</option>
						<option value="WTP">Holyrood (near St John's)</option>
						<option value="XME">Marble Mountain</option>
						<option value="XMB">Marion Bridge (near Sydney)</option>
					</optgroup>
				</select>
			</td>
		</tr>
	</table>
	<div style='width:98%;margin:0 auto;text-align:center;font-size:0.7em;font-variant:small-caps;padding-top:10px'>
		<?php echo lang('data source','c')?>: Environment Canada
	</div>
	<div id="caRadarWindow"></div>
	<script>
		dialogHeight = screen.height*0.8;
		dialogWidth = screen.width*0.6;
		$("#caRadarWindow").dialog({
			modal: true,
			autoOpen: false,
			height: dialogHeight,
			width: dialogWidth
		});
		
		$(".radarCaImage").click(function(){
			urlRadar = $(this).attr('src');
			$("#caRadarWindow").html("<div style='height:98%;margin:0 auto;text-align:center'><img src='"+urlRadar+"' style='height:98%'></div>");
			$("#caRadarWindow").dialog('open');	
		});	
		
		imageSrcsRadarCA = ['<?php echo implode("','",$imageUrlsRadarCanada)?>'];
		radarImgsCaCount = <?php echo (count($imageUrlsRadarCanada)-1)?>;
		
		$( "#sliderRadarCA" ).slider({
			value: radarImgsCaCount,
			min: 0,
			max: radarImgsCaCount,
			step: 1,
			slide: function( event, ui ) {
				$("#canadaNationalRadar").attr('src',imageSrcsRadarCA[ui.value]);
			}
		});
		
		$('#canadaRegionalRadarSelector').change(function() {
		  canadaLoadRegional($(this).val());
		});
		function canadaLoadRegional(id){
			$("#radarCASpinnerRegional").html('<img src="<?php echo $pageURL.$path?>icons/logo.png" style="width:50px" class="mtSpinner">');
			$.ajax({
				url : "homepage/blocks/radarCA/canadaRadarAjax.php?id="+id,
				success : function (result) {
					$("#canadaRegionalRadar").load(function() {
						$("#radarCASpinnerRegional").html('');
					}).attr('src', result);	
				}
			});
			$("#canadaRegionalRadarSelector").val(id);
		}
		canadaLoadRegional("<?php echo $regionalRadarCanada?>");
		
		$("#playRadarCA").click(function(){
			intervalRadarCA = setInterval(function () {
				playCARadar();
			}, 300);
			$("#pauseRadarCA").click(function(){
				clearInterval(intervalRadarCA);
			});
		});
		function playCARadar(){
			var sliderCACurrent = eval($("#sliderRadarCA").slider("value"));
			if(sliderCACurrent < <?php echo (count($imageUrlsRadarCanada)-1)?>){
				sliderCACurrent = sliderCACurrent + 1;
			}
			else{
				sliderCACurrent = 0;
			}
			$("#canadaNationalRadar").attr('src',imageSrcsRadarCA[sliderCACurrent]);
			$("#sliderRadarCA").slider('value',sliderCACurrent);
		}
		$(window).on("load", function() {
			nationalCAHeight = $("#canadaNationalRadar").height();
			$("#canadaRegionalRadar").height(nationalCAHeight);
		});
		
		
	</script>
	
	<?php 
		$time = microtime();
		$time = explode(' ', $time);
		$time = $time[1] + $time[0];
		$blockEndTime = $time;
		$blockLoadTime = $blockEndTime - $blockStartTime;
		$blockLoadTime = round($blockLoadTime,4);
		$errorLog[] = array("","Block loaded in ".$blockLoadTime." s.");
		showLog($errorLog);
	?>